kl_find_command equ &bcd4
kl_rom_walk equ &bccb

org &8000

start:
call kl_rom_walk

ld hl,read_sector_cmd_name
call kl_find_command
ld (read_sector_cmd+0),hl
ld a,c
ld (read_sector_cmd+2),a

ld hl,write_sector_cmd_name
call kl_find_command
ld (write_sector_cmd+0),hl
ld a,c
ld (write_sector_cmd+2),a

ld hl,format_track_cmd_name
call kl_find_command
ld (format_track_cmd+0),hl
ld a,c
ld (format_track_cmd+2),a

ld hl,move_track_cmd_name
call kl_find_command
ld (move_track_cmd+0),hl
ld a,c
ld (move_track_cmd+2),a

ld hl,get_drive_status_cmd_name
call kl_find_command
ld (get_drive_status_cmd+0),hl
ld a,c
ld (get_drive_status_cmd+2),a

xor a
ld (drive),a
call test_drive
ld a,1
ld (drive),a
call test_drive
rst 0

test_drive:
ld a,(drive)
ld e,a
xor a
ld b,40
seek_loop:
push af
push bc

ld d,a
rst &18
defw move_track_cmd
jr c,seek_loop2
;; drive B:
;; A=0x048
;; HL=0x0be4b
;; 0x0be4b: 0x02,0x068,0x00

pop bc
pop af
jr done_seek

seek_loop2:
pop bc
pop af
inc a
djnz seek_loop
done_seek:


ld a,(drive)
rst &18
defw get_drive_status_cmd
;; A:
;; A=0x040
;; HL=0x0be4b
;; 0x0be4b: 0x01, 0x060
;; B:
;; A=0x011
;; HL=0x0be4b
;; 0x0be4b: 0x01, 0x011


ld a,(drive)
ld e,a
ld d,0
ld c,&c1
ld hl,&4000
rst &18
defw write_sector_cmd
;; Write protected A:
;; A=0x042
;; BC=0x00c1
;; HL=0x0be4b
;; 0x0be4b: 0x07,0x040,0x02,0x00,0x00,0x00,0x0c1,0x02
;; Drive B:
;; A=0x048
;; 0x0be4b: 0x02,0x068,0x00

ld a,(drive)
ld e,a
ld d,0
ld hl,&4000
rst &18
defw format_track_cmd
;; same as write sector

;; now read
ld d,0
ld e,&c1
ld b,40
rt:
push de
push bc

ld c,e
ld hl,&4000
ld a,(drive)
ld e,a
rst &18
defw read_sector_cmd
;; drive A:
;; A = 0x0
;; HL=0x04000
;; BE4B=0x07, 0x040,0x080,0x00,0x00,0x00,0x0c1,0x02
;; drive B:
;; A = 0x048
;; HL=0x0be4b
;; be4b:0x02, 0x068,0x00

pop bc
pop de

inc e
ld a,e
cp &ca
jr nz,rt
ld e,&c1
inc d
ld a,d
cp 40
jr nz,rt

ret

drive:
defb 0

read_sector_cmd:
defs 3
write_sector_cmd:
defs 3
format_track_cmd:
defs 3
move_track_cmd:
defs 3
get_drive_status_cmd:
defs 3



read_sector_cmd_name:
defb &84
write_sector_cmd_name:
defb &85
format_track_cmd_name:
defb &86
move_track_cmd_name:
defb &87
get_drive_status_cmd_name:
defb &88



end start
